#!/usr/bin/php
<?php
error_reporting (E_ALL ^ E_NOTICE);


require_once('../microtime.php');
require_once('../misc.php');

require_once('./class.t3lib_div.php');

// Used data
require_once('./data_parsehtml.php');
// The observed classes
require_once('./class.t3lib_parsehtml.php');
require_once('./class.t3lib_parsehtml_new.php');


$cnt = 30;

$argCnt = intval($argv[1]);
$check_diff = intval($argv[2]);

if ($argCnt)	{
	$cnt = $argCnt;
}

if ($check_diff)	{
	$cnt = 1;
}

$oldClass = new t3lib_parsehtml();
$newClass = new t3lib_parsehtml_new();

echo "Iterations: $cnt\n";

$DATA_checkTagTypeCounts = array();
$data = file('./test1.html');
$DATA_checkTagTypeCounts[] = array(implode('', $data), 1);
$data = file('./test2.html');
$DATA_checkTagTypeCounts[] = array(implode('', $data), 1);
$data = file('./test3.html');
$DATA_checkTagTypeCounts[] = array(implode('', $data), 1);

$fos = 0;
foreach ($OPTIONS_checkTagTypeCounts as $OPT)	{
	$fos++;
	$o = 0;
	echo "\n\n\nFunction-Option Set $fos:\n";
	foreach ($OPT as $OPTval)	{
		echo "OPT[$o] = $OPTval\n";
	}
	echo "\n";
	$tds = 0;
	foreach ($DATA_checkTagTypeCounts as $DATA)	{
		$str = $DATA[0];
		$mustMatch = $DATA[1];
		if (is_array($mustMatch))	{
			$mustMatch = $mustMatch[$fos-1];
		}
		$tds++;
		echo "\nTest-Data Set $tds:\n";
		if ($check_diff)	{
			echo "Data '".$str."'\n";
		}
	
			echo "Testing old ... ";
		$start = get_microtime();
		for ($x = 0; $x < $cnt; $x++)	{
			$part = $oldClass->checkTagTypeCounts($str);
			if ($x==0)	{
				if ($check_diff)	{
					echo "Old result: \n";
					print_r($part);
					echo "\n----------------------------------------------------------------\n";
				}
				$old = $part;
			}
		}
		$stop = get_microtime();
		echo ($ot = ($stop-$start))." seconds\n";
		$oldTime += $ot;
	
		echo "Testing new ... ";
		$start = get_microtime();
		for ($x = 0; $x < $cnt; $x++)	{
			$part = $newClass->checkTagTypeCounts($str);
			if ($x==0)	{
				if ($check_diff)	{
					echo "New result: \n";
					print_r($part);
					echo "\n----------------------------------------------------------------\n";
				}
				$new = $part;
			}
		}
		$stop = get_microtime();
		echo ($nt = ($stop-$start))." seconds\n";
		$newTime += $nt;

		if (!array_same_rec($old, $new))	{
			if ($mustMatch)	{
				echo 'DIDN\'T match but HAVE to !'.chr(10);
				echo "ERROR !!!\n";
				exit();
			} else	{
				echo 'DIDN\'T match and NOT required !'.chr(10);
				echo "OK !!!\n";
			}
		} else	{
			if ($mustMatch)	{
				echo 'MATCHED !'.chr(10);
				echo "OK !!!\n";
			} else	{
				echo 'MATCHED but should NOT !'.chr(10);
				echo "ERROR !!!\n";
				exit();
			}
		}
	}
}

echo "Total time old: $oldTime (100%)\n";
$n = 100*$newTime/$oldTime;
$p = sprintf('%.2f', $n);
echo "Total time new: $newTime ($p%)\n";

?>
