#!/usr/bin/php
<?php
error_reporting (E_ALL ^ E_NOTICE);


require_once('./data_parsehtml.php');
require_once('../microtime.php');

require_once('./class.t3lib_parsehtml.php');
require_once('./class.t3lib_parsehtml_new.php');


$cnt = 10000;

$argCnt = intval($argv[1]);
$check_diff = intval($argv[2]);

if ($argCnt)	{
	$cnt = $argCnt;
}

if ($check_diff)	{
	$cnt = 1;
}

$oldClass = new t3lib_parsehtml();
$newClass = new t3lib_parsehtml_new();

echo "Iterations: $cnt\n";

$tds = 0;
foreach ($DATA_getSubpart as $DATA)	{
	$str = $DATA[0];
	$mustMatch = $DATA[1];
	$tds++;
	echo "Test-Data Set: $tds\n";

	echo "Testing old ... ";
	$start = get_microtime();
	for ($x = 0; $x < $cnt; $x++)	{
		$part = $oldClass->getSubpart($str, '###PART###');
		if ($x==0)	{
			if ($check_diff)	{
				echo "Old result: \n'$part'\n----------------------------------------------------------------\n";
			}
			$old = $part;
		}
	}
	$stop = get_microtime();
	echo ($ot = ($stop-$start))." seconds\n";
	$oldTime += $ot;


	echo "Testing new ... ";
	$start = get_microtime();
	for ($x = 0; $x < $cnt; $x++)	{
		$part = $newClass->getSubpart($str, '###PART###');
		if ($x==0)	{
			if ($check_diff)	{
				echo "New result: \n'$part'\n----------------------------------------------------------------\n";
			}
			$new = $part;
		}
	}
	$stop = get_microtime();
	echo ($nt = ($stop-$start))." seconds\n";
	$newTime += $nt;

	if ($old!=$part)	{
		if ($mustMatch)	{
			echo 'DIDN\'T match but HAVE to !'.chr(10);
			exit();
		} else	{
			echo 'DIDN\'T match but NOT required !'.chr(10);
		}
	} else	{
		if ($mustMatch)	{
			echo 'MATCHED !'.chr(10);
		} else	{
			echo 'MATCHED but should NOT !'.chr(10);
			exit();
		}
	}
}

echo "Total time old: $oldTime (100%)\n";
$n = 100*$newTime/$oldTime;
$p = sprintf('%.2f', $n);
echo "Total time new: $newTime ($p%)\n";

?>
